#race data
library(dplyr)
library(tidyverse)
dat = read.csv("/home/anna/ROBOCZE/TRUMP/nhgis0130_csv/nhgis0130_ds225_20165_county_E.csv")
dat1 = read.csv("/home/anna/ROBOCZE/TRUMP/nhgis0130_csv/nhgis0131_ds226_20165_county_E.csv")
dat2 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0133_csv/nhgis0133_ds225_20165_county.csv") #education by sex
dat3 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0134_csv/nhgis0134_ds226_20165_county_E.csv")
dat4 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0134_csv/nhgis0134_ds225_20165_county_E.csv")
dat5 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0135_csv/nhgis0135_ds225_20165_county_E.csv")
dat6 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0136_csv/nhgis0136_ds191_20125_county.csv") # income and pop in 2008-2012
dat7 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0136_csv/nhgis0136_ds225_20165_county.csv") # income and pop in 2012-2016
dat8 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0139_csv/nhgis0139_ds225_20165_county_E.csv") #median income and per capita
dat9 = read.csv("/home/anna/ROBOCZE/TRUMP/dane/nhgis0139_csv/nhgis0139_ds226_20165_county_E.csv") #median income and per capita
########### R A C E   
races = dat[, c("GISJOIN", "AF2UE001", "AF2UE003", "AF2UE004", "AF2UE005", "AF2UE006", "AF2UE007", "AF2UE008", "AF2UE009", "AF2UE012")]
colnames(races) = c("GISJOIN", "POP", "WHITE", "BLACK", "AM", "ASIAN", "PI", "OR", "TR", "HISPANIC")
races$ASIAN_PI = races$ASIAN + races$PI
races$OTHERS = races$OR + races$TR

#calculate percentage of race
perc_race = races[,c("WHITE", "BLACK", "AM", "ASIAN_PI", "OTHERS", "HISPANIC")]/races[,"POP"]
perc_race$GISJOIN = races$GISJOIN
perc_race = perc_race[, c("GISJOIN","WHITE", "BLACK", "AM", "ASIAN_PI", "OTHERS", "HISPANIC")]
colnames(perc_race) = c("GISJOIN",  "race_white", "race_black", "race_am", "race_asian_pi", "race_others", "race_hispanic")
################################################################################

########### A G E
sel_age = select(dat, "GISJOIN",starts_with('AF2A'))
age = data.frame(GISJOIN= sel_age$GISJOIN, total = sel_age$AF2AE001)
age$male = dat$AF2AE002
age$female = dat$AF2AE026

age$age_0_17 = apply(sel_age[, c(paste("AF2AE00", 3:6, sep=""), paste("AF2AE0", 27:30, sep=""))], 1, sum, na.rm=TRUE)
age$age_18_34 = apply(sel_age[, c(paste("AF2AE00", 7:9, sep=""), paste("AF2AE0", 10:12, sep=""), paste("AF2AE0", 31:36, sep=""))], 1, sum, na.rm=TRUE)
age$age_35_64 = apply(sel_age[, c(paste("AF2AE0", 13:19, sep=""), paste("AF2AE0",37:43, sep=""))], 1, sum, na.rm=TRUE)
age$age_over65 = apply(sel_age[, c(paste("AF2AE0", 20:25, sep=""), paste("AF2AE0", 44:49, sep=""))], 1, sum, na.rm=TRUE)
#age$age_male_0_17 = apply(sel_age[, c('AF2AE003', 'AF2AE004',  'AF2AE005', 'AF2AE006')], 1, sum, na.rm=TRUE)
#age$age_male_18_29 = apply(sel_age[, c('AF2AE007', 'AF2AE008', 'AF2AE009', 'AF2AE010', 'AF2AE011')], 1, sum, na.rm=TRUE)
#age$age_male_30_49 = apply(sel_age[, c('AF2AE012', 'AF2AE013', 'AF2AE014', 'AF2AE015')], 1, sum, na.rm=TRUE)
#age$age_male_50_64 = apply(sel_age[, c('AF2AE016', 'AF2AE017', 'AF2AE018', 'AF2AE019')], 1, sum, na.rm=TRUE)
#age$age_male_65 = apply(sel_age[, c('AF2AE020', 'AF2AE021', 'AF2AE022', 'AF2AE023', 'AF2AE024', 'AF2AE025')], 1, sum, na.rm=TRUE)

#age$age_female_0_17 = apply(sel_age[, c('AF2AE027', 'AF2AE028', 'AF2AE029', 'AF2AE030')], 1, sum, na.rm=TRUE)
#age$age_female_18_29 = apply(sel_age[, c('AF2AE031', 'AF2AE032', 'AF2AE033', 'AF2AE034', 'AF2AE035')], 1, sum, na.rm=TRUE)
#age$age_female_30_49 = apply(sel_age[, c('AF2AE036', 'AF2AE037', 'AF2AE038', 'AF2AE039')], 1, sum, na.rm=TRUE)
#age$age_female_50_64 = apply(sel_age[, c('AF2AE040', 'AF2AE041', 'AF2AE042', 'AF2AE043')], 1, sum, na.rm=TRUE)
#age$age_female_65 = apply(sel_age[, c('AF2AE044', 'AF2AE045', 'AF2AE046', 'AF2AE047', 'AF2AE048', 'AF2AE049')], 1, sum, na.rm=TRUE)

perc_sex = age[, c("male", "female")]/(age$male+age$female)
perc_sex$GISJOIN = age$GISJOIN
colnames(perc_sex) = c("sex_male", "sex_female", "GISJOIN")
perc_age = age[, 5:8]/age[, "total"]

perc_age$GISJOIN = age$GISJOIN


################################################################################
########### E D U C A T I O N
sel_edu = select(dat2, "GISJOIN",starts_with('AF4NE'))
education = data.frame(GISJOIN= sel_edu$GISJOIN, total = sel_edu$AF4NE001, male = sel_edu$AF4NE002, female = sel_edu$AF4NE019)

#basic is no school or up to 12 grade 
#medium is High school graduate, college, associated degrees
#high is a academic (bachelor, master, doctoral, proffesional school degreen)
#education$edu_male_basic = apply(sel_edu[, c(paste("AF4NE00", 3:9, sep=""), paste("AF4NE0", 10, sep=""))], 1, sum, na.rm=TRUE)
#education$edu_male_medium = apply(sel_edu[, paste("AF4NE0", 11:14, sep="")], 1, sum, na.rm=TRUE)
education$edu_male_high = apply(sel_edu[, paste("AF4NE0", 15:18, sep="")], 1, sum, na.rm=TRUE)
#education$edu_female_basic = apply(sel_edu[, paste("AF4NE0", 20:27, sep="")], 1, sum, na.rm=TRUE)
#education$edu_female_medium = apply(sel_edu[, paste("AF4NE0", 28:31, sep="")], 1, sum, na.rm=TRUE)
education$edu_female_high =  apply(sel_edu[, paste("AF4NE0", 32:35, sep="")], 1, sum, na.rm=TRUE)
education$high = education$edu_male_high + education$edu_female_high
edu_high = education$high/education$total

perc_edu = data.frame(GISJOIN = education$GISJOIN, edu_high = edu_high)

#perc_edu_male = education[,5:7]/education[,3]
#perc_edu_female = education[,8:10]/education[,4]
#perc_edu = cbind(perc_edu_male, perc_edu_female)
#perc_edu$GISJOIN = education$GISJOIN



################################################################################
########### P O V E R T Y
sel_pov = select(dat, "GISJOIN",starts_with('AF43'))
poverty = data.frame(GISJOIN= sel_pov$GISJOIN)
poverty$total = sel_pov$AF43E001
poverty$pov_under_1 = apply(sel_pov[, c('AF43E002','AF43E003')], 1, sum, na.rm=TRUE)
poverty$pov_over_1 = apply(sel_pov[, c('AF43E004','AF43E005', 'AF43E006', 'AF43E007', 'AF43E008')], 1, sum, na.rm=TRUE)

perc_pov = poverty[,-c(1,2)]/poverty$total
perc_pov$GISJOIN = poverty$GISJOIN

################################################################################
########### I N C O M E
#sel_income = select(dat, "GISJOIN",starts_with('AF48'))
#income = data.frame(GISJOIN= sel_income$GISJOIN)
#income$total = sel_income$AF48E001
#income$income_less_30 =  apply(sel_income[, paste("AF48E00", 2:6, sep="")], 1, sum, na.rm=TRUE)
#income$income_30_75 =  apply(sel_income[, c(paste("AF48E00", 7:9, sep=""), paste("AF48E0", 10:12, sep=""))], 1, sum, na.rm=TRUE)
#income$income_more_75 =  apply(sel_income[, paste("AF48E0", 13:17, sep="")], 1, sum, na.rm=TRUE)

#perc_income = income[,-c(1,2)]/income$total
#perc_income$GISJOIN = income$GISJOIN


################################################################################
########### INCOME DATA
sel_income = select(dat8, "GISJOIN",starts_with('AF'))
colnames(sel_income) = c("GISJOIN", "income_median", "income_percapita")

sel_income2 = select(dat9, "GISJOIN",starts_with('AGL'))
colnames(sel_income2) = c("GISJOIN", "total","public_asist", "no_public_asist", "gini_index")
sel_income2$public_asist = sel_income2$public_asist/sel_income2$total
sel_income2$no_public_asist = sel_income2$no_public_asist/sel_income2$total

income = merge(sel_income, sel_income2[, -2], by = "GISJOIN")
################################################################################
########### E M P L O Y M E N T
employment = dat[, c("GISJOIN", "AF67E004", "AF67E005", "AF67E006", "AF67E007")] 
colnames(employment) = c("GISJOIN", "empl_civilian_employed", "empl_civilian_unemployed", "empl_armed", "empl_not_in_labor")
employment$total = apply(employment[,-1], 1, sum, na.rm=TRUE)
employment = employment[,  c("GISJOIN","total", "empl_civilian_employed", "empl_civilian_unemployed", "empl_armed", "empl_not_in_labor")]

perc_empl = employment[,-c(1,2)]/employment[,"total"]
perc_empl$GISJOIN = employment$GISJOIN

work_occupation = dat1[, c("GISJOIN", "AGO6E001","AGO6E015", "AGO6E029", "AGO6E043", "AGO6E057", "AGO6E071")]
colnames(work_occupation) = c("GISJOIN", "total", "work_management", "work_service", "work_sales", "work_natural", "work_production")

industry = dat1[, c("GISJOIN", paste("AGO6E00", 1:9, sep=""), paste("AGO6E0", 10:14, sep=""))]
colnames(industry) = c("GISJOIN", "total", "ind_agriculture", "ind_construction", "ind_manufacturing", "ind_wholesale", "ind_retail", "ind_transport", "ind_information", "ind_finanse", "ind_prof_services", "ind_education", "ind_recreation", "ind_other_services", "ind_public_adm")

perc_work = work_occupation[, -c(1,2)]/work_occupation[, "total"]
perc_work$GISJOIN = work_occupation$GISJOIN

perc_industry = industry[, -c(1,2)]/industry[, "total"]
perc_industry$GISJOIN = industry$GISJOIN

################################################################################
########### CLASS OF WORKERS 

sel_workers = select(dat3, "GISJOIN",starts_with('AGO8'))
workers = data.frame(GISJOIN= sel_workers$GISJOIN, total = sel_workers$AGO8E001)
self = apply(sel_workers[, paste("AGO8E0", 30:42, sep="")], 1, sum, na.rm=TRUE)
workers$workers_salary =  sel_workers$AGO8E015 + sel_workers$AGO8E043 + self
workers$workers_goverment = sel_workers$AGO8E057
workers$workers_self = sel_workers$AGO8E071

perc_workers = workers[, 3:5]/workers[,2]
perc_workers$GISJOIN = workers$GISJOIN  

################################################################################
########### H E A L T H     I N S U A R A N C E 
sel_health = select(dat, "GISJOIN",starts_with('AF90'))
health_ins = data.frame(GISJOIN= sel_health$GISJOIN)

health_ins$total = sel_health$AF90E002 + sel_health$AF90E018 + sel_health$AF90E034
health_ins$insured_under65 = sel_health$AF90E003 + sel_health$AF90E010 + sel_health$AF90E019 + sel_health$AF90E026 + sel_health$AF90E035+ sel_health$AF90E042

#health_ins$health_under18_yes = apply(sel_health[, c('AF90E003','AF90E010')], 1, sum, na.rm=TRUE)
#health_ins$health_under18_no = sel_health$AF90E017
#health_ins$health_18_34_yes = apply(sel_health[, c('AF90E019','AF90E026')], 1, sum, na.rm=TRUE)
#health_ins$health_18_34_no = sel_health$AF90E033
#health_ins$health_35_64_yes = apply(sel_health[, c('AF90E035','AF90E042')], 1, sum, na.rm=TRUE)
#health_ins$health_35_64_no = sel_health$AF90E050
#health_ins$health_over65_yes = apply(sel_health[, c('AF90E052','AF90E058')], 1, sum, na.rm=TRUE)
#health_ins$health_over65_no = sel_health$AF90E066

perc_health = data.frame(GISJOIN = health_ins$GISJOIN)
perc_health$insured_under65 =   health_ins[,3]/health_ins$total


################################################################################
########### H O U S E   O C C U P A N C Y
house_occupancy = dat[, c("GISJOIN", "AF7OE001", "AF7OE002", "AF7OE003")]
colnames(house_occupancy) = c("GISJOIN", "total", "house_occupied", "house_vacant")
 
perc_occ = house_occupancy[, -c(1,2)]/house_occupancy[, "total"]
perc_occ$GISJOIN = house_occupancy$GISJOIN
################################################################################
########### T E N U R E
tenure = dat[, c("GISJOIN", "AF7PE001", "AF7PE002", "AF7PE003" )]
colnames(tenure) = c("GISJOIN", "total", "tenure_owner_occupied", "tenure_renter_occupied")

perc_tenure = tenure[, -c(1,2)]/tenure[,"total"]
perc_tenure$GISJOIN = tenure$GISJOIN

################################################################################
########### C I T I Z E N S H I P
sel_citizen = select(dat3, "GISJOIN",starts_with('AGCDE'))
citizen = data.frame(GISJOIN= sel_citizen$GISJOIN, total = sel_citizen$AGCDE001)
citizen$cit_us_citizen = apply(sel_citizen[, paste("AGCDE00", 2:4, sep="")], 1, sum, na.rm=TRUE)
citizen$cit_us_citizen_nat = sel_citizen$AGCDE005
citizen$cit_not_us_citizen = sel_citizen$AGCDE006


perc_citizen = citizen[, -c(1,2)]/citizen[,"total"]
perc_citizen$GISJOIN = citizen$GISJOIN

################################################################################
########### G E O G R A P H I C A L   M O B I L I T Y
#sel_mobility = select(dat3, "GISJOIN",starts_with('AGD8'))
#mobility = data.frame(GISJOIN= sel_mobility$GISJOIN, total = sel_mobility$AGD8E001)

#mobility$same_house = sel_mobility$AGD8E004
#mobility$moved_same_county = sel_mobility$AGD8E007
#mobility$moved_state = sel_mobility$AGD8E010 + sel_mobility$AGD8E013 #different county same state, different state
#mobility$moved_abroad = sel_mobility$AGD8E016

#perc_mobility = mobility[,3:6]/mobility[,2]
#perc_mobility = mobility$GISJOIN

sel_mobility = select(dat3, "GISJOIN",starts_with('AGE7'))
mobility = data.frame(GISJOIN= sel_mobility$GISJOIN, total = sel_mobility$AGE7E001)
mobility$mobility_same_house = sel_mobility$AGE7E002
mobility$mobility_same_city = apply(sel_mobility[, c(paste("AGE7E00", 4:6, sep=""), paste("AGE7E00", 8, sep=""))], 1, sum, na.rm=TRUE) #same city, elsewhere but same county
mobility$mobility_different_house = sel_mobility$AGE7E009 #different county, different state
mobility$mobility_abroad = sel_mobility$AGE7E016 #abroad

perc_mobility = mobility[,3:6]/mobility[,2]
perc_mobility$GISJOIN = mobility$GISJOIN

################################################################################
########### MEANS OF TRANSPORTATION
sel_transport = select(dat4, "GISJOIN", starts_with('AF3BE'))
transport = data.frame(GISJOIN= sel_transport$GISJOIN, total = sel_transport$AF3BE001)

transport$transp_car = sel_transport$AF3BE002
transport$transp_public = sel_transport$AF3BE010
transport$transp_bike = apply(sel_transport[, c(paste("AF3BE0", 16:19, sep=""))], 1, sum, na.rm=TRUE) #including taxi, motorbike and walk
transport$transp_other = sel_transport$AF3BE020
transport$transp_work_at_home = sel_transport$AF3BE021

perc_transport = transport[,3:7]/transport[,2]
perc_transport$GISJOIN = transport$GISJOIN
################################################################################
########### MARRIAGE STATUS
sel_marriage = select(dat4, "GISJOIN", starts_with('AF4AE'))
marriage = data.frame(GISJOIN= sel_marriage$GISJOIN, total = sel_marriage$AF4AE001)
marriage$marriage_never_married = sel_marriage$AF4AE003 + sel_marriage$AF4AE012
marriage$marriage_married = sel_marriage$AF4AE004 + sel_marriage$AF4AE013
marriage$marriage_widowed = sel_marriage$AF4AE009 + sel_marriage$AF4AE018
marriage$marriage_divorced = sel_marriage$AF4AE010 + sel_marriage$AF4AE019


marriage_ind_divorce = marriage$marriage_divorced/marriage$marriage_married 
marriage_never_married = marriage$marriage_never_married/marriage$total
perc_marriage = data.frame(ind_divorce = marriage_ind_divorce, marriage_never_married = marriage_never_married , GISJOIN = marriage$GISJOIN)
#perc_marriage = marriage[,3:6]/marriage[,2]
#perc_marriage$GISJOIN = marriage$GISJOIN
################################################################################
########### LANGUAGE
sel_lang = select(dat4, "GISJOIN", starts_with('AF41'))
lang = data.frame(GISJOIN= sel_lang$GISJOIN, total = sel_lang$AF41E001)
lang$lang_only_english = sel_lang$AF41E002
lang$lang_limited_eng = sel_lang$AF41E004 + sel_lang$AF41E007 + sel_lang$AF41E010 + sel_lang$AF41E013
lang$lang_not_limited_eng = sel_lang$AF41E005 + sel_lang$AF41E008 + sel_lang$AF41E011 + sel_lang$AF41E014

perc_lang = lang[,3:5]/lang[,2]
perc_lang$GISJOIN = lang$GISJOIN
################################################################################
########### TENURE BY YEAR
sel_tenure_yr = select(dat4, "GISJOIN", starts_with('AF8LE'))
tenure_yr  = data.frame(GISJOIN= sel_tenure_yr$GISJOIN, total = sel_tenure_yr$AF8LE001, owner = sel_tenure_yr$AF8LE002, renter = sel_tenure_yr$AF8LE009)
tenure_yr$tenyr_owner_2015 = sel_tenure_yr$AF8LE003
tenure_yr$tenyr_owner_2010_14 = sel_tenure_yr$AF8LE004
tenure_yr$tenyr_owner_2000_09 = sel_tenure_yr$AF8LE005
tenure_yr$tenyr_owner_bef_2000 = apply(sel_tenure_yr[, c(paste("AF8LE00", 6:8, sep=""))], 1, sum, na.rm=TRUE)

tenure_yr$tenyr_rent_2015 = sel_tenure_yr$AF8LE010
tenure_yr$tenyr_rent_2010_14 = sel_tenure_yr$AF8LE011
tenure_yr$tenyr_rent_2000_09 = sel_tenure_yr$AF8LE012
tenure_yr$tenyr_rent_bef_2000 = apply(sel_tenure_yr[, c(paste("AF8LE0", 13:15, sep=""))], 1, sum, na.rm=TRUE)

perc_tenure_yr_owner = tenure_yr[,5:8]/tenure_yr[,3]
perc_tenure_yr_renter = tenure_yr[,9:12]/tenure_yr[,4]
perc_tenure_yr = cbind(perc_tenure_yr_owner, perc_tenure_yr_renter)
perc_tenure_yr$GISJOIN = tenure_yr$GISJOIN



################################################################################
########### HOUSING VALUES
house_value = dat5[, c("GISJOIN", "AF9KE001", "AF9LE001", "AF9ME001")]
colnames(house_value) = c("GISJOIN", "housevalue_Q1", "housevalue_median", "housevalue_Q3")

#######################
library(sf)
cnt = st_read("/home/anna/ROBOCZE/TRUMP/us_county_2016/US_county_2016_attr.shp")
sel_cnt = cnt[, c("GISJOIN", "AREA")]
################################################################################
########### DYNAMIC VARIABLES 

dyn08_12 = dat6[, c("GISJOIN", "QSPE001", "QU1E001", "QVBE001")]
colnames(dyn08_12) = c("GISJOIN", "POP08", "MEDIAN_INCOME08", "AGG_INCOME08")

dyn12_16 = dat7[, c("GISJOIN", "AF2LE001", "AF49E001", "AF5AE001")]
colnames(dyn12_16) = c("GISJOIN", "POP16", "MEDIAN_INCOME16", "AGG_INCOME16")
  
dyn = merge(dyn12_16, dyn08_12, by = "GISJOIN", all=TRUE)
dyn = merge(dyn, sel_cnt, by = "GISJOIN")

dyn$POP08dens = dyn$POP08/dyn$AREA
dyn$POP16dens = dyn$POP16/dyn$AREA

dyn$POP08_16 = (dyn$POP16dens-dyn$POP08dens)/dyn$POP08dens

dyn$MEDIAN_INCOME08_16 =  (dyn$MEDIAN_INCOME16-dyn$MEDIAN_INCOME08)/dyn$MEDIAN_INCOME08


#################################################################################
list_df = list(perc_race, perc_citizen, perc_sex, perc_age, perc_marriage, perc_lang, perc_edu, perc_empl, perc_workers, perc_industry, perc_work, perc_transport, perc_pov, income,
               perc_health, perc_occ, perc_tenure, perc_tenure_yr, perc_mobility, house_value, dyn)

df =  reduce(list_df, full_join, by='GISJOIN')


###################################################

geo = read.csv("/home/anna/ROBOCZE/TRUMP/nhgis0130_csv/geography.csv", colClasses = 'character')
pres = read.csv("/home/anna/ROBOCZE/TRUMP/data/2016_US_County_Level_Presidential_Results.csv")
colnames(pres) = paste("election_", names(pres), sep="")
head(pres)
geo$county_code = paste(as.integer(geo$STATEA), geo$COUNTYA, sep="")
geo$FIPS = paste(geo$STATEA, geo$COUNTYA, sep="")
#county code from geo = combined fips from pres

library(readxl)
urbanrural = read_excel("/home/anna/ROBOCZE/TRUMP/ruralurbancodes2013.xls", sheet = 1)

geo = merge(geo, urbanrural[, c("FIPS", "RUCC_2013")], by = "FIPS", all.x = TRUE)

#final dataset 
x = merge(geo, pres[, c("election_votes_dem", "election_votes_gop", "election_total_votes", "election_per_dem", "election_per_gop", "election_combined_fips")], by.x = "county_code", by.y = "election_combined_fips", all.x = TRUE)

final_dataset = merge(x, df, by = "GISJOIN")

#with dynamics
#final_dataset = merge(final_dataset, dyn, by = "GISJOIN", all.x = TRUE)

names(final_dataset)

write.csv(final_dataset, "variables2016_final_dataset_v4.csv", row.names = FALSE)
