#race data
library(dplyr)
dat = read.csv("/home/anna/ROBOCZE/TRUMP/nhgis0130_csv/nhgis0130_ds225_20165_county_E.csv")

########### R A C E   
races = dat[, c("GISJOIN", "AF2UE001", "AF2UE003", "AF2UE004", "AF2UE005", "AF2UE006", "AF2UE007", "AF2UE008", "AF2UE009", "AF2UE012")]
colnames(races) = c("GISJOIN", "POP", "WHITE", "BLACK", "AM", "ASIAN", "PI", "OR", "TR", "HISPANIC")
races$ASIAN_PI = races$ASIAN + races$PI
races$OTHERS = races$OR + races$TR

#calculate percentage of race
perc_race = races[,c("WHITE", "BLACK", "AM", "ASIAN_PI", "OTHERS", "HISPANIC")]/races[,"POP"]
perc_race$GISJOIN = races$GISJOIN
################################################################################

########### A G E
sel_age = select(dat, "GISJOIN",starts_with('AF2A'))
age = data.frame(GISJOIN= sel_age$GISJOIN)
age$male = dat$AF2AE002
age$female = dat$AF2AE026
age$age_male_0_17 = apply(sel_age[, c('AF2AE003', 'AF2AE004',  'AF2AE005', 'AF2AE006')], 1, sum, na.rm=TRUE)
age$age_male_18_29 = apply(sel_age[, c('AF2AE007', 'AF2AE008', 'AF2AE009', 'AF2AE010', 'AF2AE011')], 1, sum, na.rm=TRUE)
age$age_male_30_49 = apply(sel_age[, c('AF2AE012', 'AF2AE013', 'AF2AE014', 'AF2AE015')], 1, sum, na.rm=TRUE)
age$age_male_50_64 = apply(sel_age[, c('AF2AE016', 'AF2AE017', 'AF2AE018', 'AF2AE019')], 1, sum, na.rm=TRUE)
age$age_male_65 = apply(sel_age[, c('AF2AE020', 'AF2AE021', 'AF2AE022', 'AF2AE023', 'AF2AE024', 'AF2AE025')], 1, sum, na.rm=TRUE)

age$age_female_0_17 = apply(sel_age[, c('AF2AE027', 'AF2AE028', 'AF2AE029', 'AF2AE030')], 1, sum, na.rm=TRUE)
age$age_female_18_29 = apply(sel_age[, c('AF2AE031', 'AF2AE032', 'AF2AE033', 'AF2AE034', 'AF2AE035')], 1, sum, na.rm=TRUE)
age$age_female_30_49 = apply(sel_age[, c('AF2AE036', 'AF2AE037', 'AF2AE038', 'AF2AE039')], 1, sum, na.rm=TRUE)
age$age_female_50_64 = apply(sel_age[, c('AF2AE040', 'AF2AE041', 'AF2AE042', 'AF2AE043')], 1, sum, na.rm=TRUE)
age$age_female_65 = apply(sel_age[, c('AF2AE044', 'AF2AE045', 'AF2AE046', 'AF2AE047', 'AF2AE048', 'AF2AE049')], 1, sum, na.rm=TRUE)

perc_sex = age[, c("male", "female")]/(age$male+age$female)

perc_age_male = age[, 4:8]/age[, "male"]
perc_age_female = age[, 9:13]/age[, "female"]


perc_age = cbind(perc_age_male, perc_age_female)
perc_age = cbind(perc_age, perc_sex)
perc_age$GISJOIN = age$GISJOIN

################################################################################
########### E D U C A T I O N
sel_edu = select(dat, "GISJOIN",starts_with('AF4O'))
education = data.frame(GISJOIN= sel_edu$GISJOIN)
education$total = sel_edu$AF4OE001
education$edu_no_school = sel_edu$AF4OE002
x = c(paste('AF4OE00', 3:9, sep=""), paste('AF4OE0', 10:16, sep=""))
education$edu_high_sch_less = apply(sel_edu[, x], 1, sum, na.rm=TRUE)
education$edu_high_sch_diploma = apply(sel_edu[, c('AF4OE017','AF4OE018')], 1, sum, na.rm=TRUE)
education$edu_college_no_degree = apply(sel_edu[, c('AF4OE019','AF4OE020')], 1, sum, na.rm=TRUE)
education$edu_degree = apply(sel_edu[, c('AF4OE021','AF4OE022', 'AF4OE023', 'AF4OE024', 'AF4OE025' )], 1, sum, na.rm=TRUE)

perc_edu = education[,3:7]/education[,2]
perc_edu$GISJOIN = education$GISJOIN

################################################################################
########### P O V E R T Y
sel_pov = select(dat, "GISJOIN",starts_with('AF43'))
poverty = data.frame(GISJOIN= sel_pov$GISJOIN)
poverty$total = sel_pov$AF43E001
poverty$pov_under_1 = apply(sel_pov[, c('AF43E002','AF43E003')], 1, sum, na.rm=TRUE)
poverty$pov_over_1 = apply(sel_pov[, c('AF43E004','AF43E005', 'AF43E006', 'AF43E007', 'AF43E008')], 1, sum, na.rm=TRUE)

perc_pov = poverty[,-c(1,2)]/poverty$total
perc_pov$GISJOIN = poverty$GISJOIN

################################################################################
########### I N C O M E
sel_income = select(dat, "GISJOIN",starts_with('AF48'))
income = data.frame(GISJOIN= sel_income$GISJOIN)
income$total = sel_income$AF48E001
income$income_less_30 =  apply(sel_income[, paste("AF48E00", 2:6, sep="")], 1, sum, na.rm=TRUE)
income$income_30_75 =  apply(sel_income[, c(paste("AF48E00", 7:9, sep=""), paste("AF48E0", 10:12, sep=""))], 1, sum, na.rm=TRUE)
income$income_more_75 =  apply(sel_income[, paste("AF48E0", 13:17, sep="")], 1, sum, na.rm=TRUE)

perc_income = income[,-c(1,2)]/income$total
perc_income$GISJOIN = income$GISJOIN

################################################################################
########### E M P L O Y M E N T
employment = dat[, c("GISJOIN", "AF67E004", "AF67E005", "AF67E006", "AF67E007")] 
colnames(employment) = c("GISJOIN", "empl_civilian_employed", "empl_civilian_unemployed", "empl_armed", "not_in_labor")
employment$total = apply(employment[,-1], 1, sum, na.rm=TRUE)
employment = employment[,  c("GISJOIN","total", "empl_civilian_employed", "empl_civilian_unemployed", "empl_armed", "not_in_labor")]

perc_empl = employment[,-c(1,2)]/employment[,"total"]
perc_empl$GISJOIN = employment$GISJOIN

################################################################################
########### H E A L T H     I N S U A R A N C E 
sel_health = select(dat, "GISJOIN",starts_with('AF90'))
health_ins = data.frame(GISJOIN= sel_health$GISJOIN, total = sel_health$AF90E001)

health_ins$health_under18_yes = apply(sel_health[, c('AF90E003','AF90E010')], 1, sum, na.rm=TRUE)
health_ins$health_under18_no = sel_health$AF90E017
health_ins$health_18_34_yes = apply(sel_health[, c('AF90E019','AF90E026')], 1, sum, na.rm=TRUE)
health_ins$health_18_34_no = sel_health$AF90E033
health_ins$health_35_64_yes = apply(sel_health[, c('AF90E035','AF90E042')], 1, sum, na.rm=TRUE)
health_ins$health_35_64_no = sel_health$AF90E050
health_ins$over65_yes = apply(sel_health[, c('AF90E052','AF90E058')], 1, sum, na.rm=TRUE)
health_ins$health_over65_no = sel_health$AF90E066

perc_health = health_ins[,-c(1,2)]/health_ins$total
perc_health$GISJOIN = health_ins$GISJOIN

################################################################################
########### H O U S E   O C C U P A N C Y
house_occupancy = dat[, c("GISJOIN", "AF7OE001", "AF7OE002", "AF7OE003")]
colnames(house_occupancy) = c("GISJOIN", "total", "house_occupied", "house_vacant")
 
perc_occ = house_occupancy[, -c(1,2)]/house_occupancy[, "total"]
perc_occ$GISJOIN = house_occupancy$GISJOIN
################################################################################
########### T E N U R E
tenure = dat[, c("GISJOIN", "AF7PE001", "AF7PE002", "AF7PE003" )]
colnames(tenure) = c("GISJOIN", "total", "owner_occupied", "renter_occupied")

perc_tenure = tenure[, -c(1,2)]/tenure[,"total"]
perc_tenure$GISJOIN = tenure$GISJOIN



################################################################################
#races
c("GISJOIN", "AF2UE001", "AF2UE003", "AF2UE004", "AF2UE005", "AF2UE006", "AF2UE007", "AF2UE008", "AF2UE009", "AF2UE012")
#races rename
c("GISJOIN", "POP", "WHITE", "BLACK", "AM", "ASIAN", "PI", "OR", "TR", "HISPANIC")

#age
#male ponizej 17
AF2AE003, AF2AE005, AF2AE006
#male 18-29
AF2AE007, AF2AE008, AF2AE009, AF2AE010, AF2AE011
#male 30-49
AF2AE012-15
#male 50-64
AF2AE016 - 19
#male 65+
AF2AE020 - 25

#female ponizej 17
AF2AE027 - 30
#male 18-29
AF2AE031-35
#female 30-49
AF2AE036 - 39
#female 50-64
AF2AE040 - AF2AE043
#female 65+
AF2AE044 - 49

#Educational Attainment for the Population 25 Years and Over
AF4OE002    No schooling completed
AF4OE003 - AF4OE016 hs or less
AF4OE017 - AF4OE018 hs diploma or ged
AF4OE019 - AF4OE020 college, no degree
AF4OE021 - AF4OE025 - degree

poverty
AF43E001:    Total
AF43E002:    Under .50
AF43E003:    .50 to .99
AF43E004:    1.00 to 1.24
AF43E005:    1.25 to 1.49
AF43E006:    1.50 to 1.84
AF43E007:    1.85 to 1.99
AF43E008:    2.00 and over

Household Income in the Past 12 Months (in 2016 Inflation-Adjusted Dollars)
AF48E002 - AF48E006 less 30000
AF48E007 - AF48E012 30 000 do 74 999
AF48E013 - 17 75 000 and more


Employment Status for the Population 16 Years and Over
AF67E004:    In labor force: Civilian labor force: Employed
AF67E005:    In labor force: Civilian labor force: Unemployed
AF67E006:    In labor force: Armed Forces
AF67E007:    Not in labor force

Occupancy Status
AF7OE002:    Occupied
AF7OE003:    Vacant

Tenure for occupied housing units
AF7PE002:    Owner occupied
AF7PE003:    Renter occupied

Year Structure Built
AF8HE001:    Total
AF8HE002:    Built 2014 or later
AF8HE003:    Built 2010 to 2013
AF8HE004:    Built 2000 to 2009
AF8HE005:    Built 1990 to 1999
AF8HE006:    Built 1980 to 1989
AF8HE007:    Built 1970 to 1979
AF8HE008:    Built 1960 to 1969
AF8HE009:    Built 1950 to 1959
AF8HE010:    Built 1940 to 1949
AF8HE011:    Built 1939 or earlier

Types of Health Insurance Coverage by Age
AF90E003:    Under 18 years: With one type of health insurance coverage
AF90E010:    Under 18 years: With two or more types of health insurance coverage
AF90E017:    Under 18 years: No health insurance coverage
AF90E019:    18 to 34 years: With one type of health insurance coverage
AF90E026:    18 to 34 years: With two or more types of health insurance coverage
AF90E033:    18 to 34 years: No health insurance coverage
AF90E035:    35 to 64 years: With one type of health insurance coverage
AF90E042:    35 to 64 years: With two or more types of health insurance coverage
AF90E050:    35 to 64 years: No health insurance coverage
AF90E052:    65 years and over: With one type of health insurance coverage
AF90E058:    65 years and over: With two or more types of health insurance coverage
AF90E066:    65 years and over: No health insurance coverage



AGO6E001:    Total
AGO6E002:    Agriculture, forestry, fishing and hunting, and mining
AGO6E003:    Construction
AGO6E004:    Manufacturing
AGO6E005:    Wholesale trade
AGO6E006:    Retail trade
AGO6E007:    Transportation and warehousing, and utilities
AGO6E008:    Information
AGO6E009:    Finance and insurance, and real estate and rental and leasing
AGO6E010:    Professional, scientific, and management, and administrative and waste management services
AGO6E011:    Educational services, and health care and social assistance
AGO6E012:    Arts, entertainment, and recreation, and accommodation and food services
AGO6E013:    Other services, except public administration
AGO6E014:    Public administration

